/*************************************************************************
(c) mgiaco, Wetterstation mit Hndy 
V 1.0
*************************************************************************/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <avr/pgmspace.h>
#include <string.h>
#include <avr/delay.h>

#include "uart.h"
#include "lcd.h"

/* CPU Frequenz in Mhz */
#ifndef F_CPU
#define F_CPU 8000000UL
#endif

/* 9600 baud Schnittstelle fuer Hndy */
#define UART_BAUD_RATE      9600      

/* Bit setzen */
#define set_bit(var, bit) ((var) |= (1 << (bit)))
/* Bit lschen */
#define clear_bit(var, bit) ((var) &= (unsigned)~(1 << (bit)))

/* Bit abfragen ==> gibts in der neuen Lib */
//#define bit_is_set(var, bit) ((var) & (1 << (bit)))
//#define bit_is_clear(var, bit) !bit_is_set(var, bit)


volatile uint16_t time1=0;
volatile uint16_t time2=0;
char rxBuffer[60];

unsigned int c;



SIGNAL (SIG_OVERFLOW0){
	
	TCNT0 = 0x9c; //100uSEc bei 8MHz und Presceller durch 8!!
	
	
	if(time1 == 5000){
		PORTB = PINB ^ ( 1 << PB0 );  /* .. LED an Port PB0 ein/aus */
		time1 = 0;		 
	}
		
	if(time2 == 2500){

		PORTB = PINB ^ ( 1 << PB1 );  /* .. LED an Port PB1 ein/aus */
		time2 = 0;
	}
	
	time1 ++;
	time2 ++;
}


 
void init(void){

	DDRB  = 0xff;	// PortB als Ausgang,	1111 1111 
    PORTB = 0x00;	// Pull`s  deaktiviert 	0000 0000
	
	DDRA  = 0x00;	// alle pins von Port A als Eingang

	TCCR0 = (1<<CS01);	// count with cpu clock/8
	TIMSK = 1<<TOIE0;	// enable TCNT0 overflow 
 	
 	TCNT0 = 0x9c;	//100uSEc bei 8Mhz
	
	uart_init( UART_BAUD_SELECT(UART_BAUD_RATE,F_CPU) );


	lcd_init(LCD_DISP_ON);
	lcd_home();			
   	lcd_clrscr();
   
}




int main(void) {
	
   	int8_t state;
	int8_t ok;
	int8_t i;
	unsigned int c;
	
	state = 0;
	i = 0;
	ok = 0;
	c = 0;

	init();
	
	sei();

   	uart_puts("AT"); uart_putc('\r');// uart_putc('\n');

	
	lcd_clrscr();
	
 for(;;){
	 
	

	c = uart_getc();
      
  	if ( c & UART_NO_DATA ){

    }else{
		if(c != '\r'){
			rxBuffer[i]=c;
			i++;
		}else{
			rxBuffer[i] = '\0';
			i = 0;
			
			lcd_gotoxy(0,0);
			lcd_puts(rxBuffer);

			if(strcmp(rxBuffer,"RING")==0){
				state = 1;
			}else state = 0;
			
			if(strcmp(rxBuffer,"OK")==0){
				state = 2;
			}else state = 0;
		}
	}

	switch(state){
		
		case 0:
			
		break;
			
		case 1:
			lcd_gotoxy(0,0);
			lcd_puts("STATE 1, RING");
			state = 0;

		break;

		case 2:
			lcd_gotoxy(0,0);
			lcd_puts("STATE 2, OK");
			state = 0;

		break;

	}
 }         
}